<script>
    import Header from '../components/Header.svelte';
    import Footer from '../components/Footer.svelte';
    import Sidebar from '../components/Sidebar.svelte';
	import { Router } from "svelte-routing";
	import { links } from "svelte-routing";
    import { onMount } from 'svelte'


    export let posts = []

	const apiUrl = siteData.env.API_URL

	let allPost
	let loadedPost
	let postPerLoad = 10
	let showLoadmore = false

	onMount(async () => {

		const allpost = await fetch(apiUrl, {
				method: "post",
				headers: { "Content-Type": "application/json" },
				body: JSON.stringify({
					query: `query allposts {
						channels {
							id
						}
					}`
				})
			}
		)
		const allPostres = await allpost.json();

		const api = await fetch(apiUrl, {
				method: "post",
				headers: { "Content-Type": "application/json" },
				body: JSON.stringify({
					query: `query channels {
						channels(orderBy: createdAt_DESC, first: ${postPerLoad}) {
							title
							content {
								html
							}
							permalink
							thumbnail {
								url
							}
						}
					}`
				})
			}
		)
		const res = await api.json();
		
		allPost = allPostres.data.channels.length
		loadedPost = res.data.channels.length
        posts = res.data.channels

		if (posts.length != 0) {
			showLoadmore = true
		}

	})

	const loadMore = () => {
		
		console.log('Loading more posts')

		fetch(apiUrl, {
				method: "post",
				headers: { "Content-Type": "application/json" },
				body: JSON.stringify({
					query: `query channels {
						channels(orderBy: createdAt_DESC, first: ${postPerLoad}, skip: ${loadedPost}) {
							title
							content {
								html
							}
							permalink
							thumbnail {
								url
							}
						}
					}`
				})
			}
		).then(
			function(res){
				
				if (res.status !== 200) {
					console.log('Looks like there was a problem. Status Code: ' +
					res.status);
					return;
				}

				res.json().then(function(data) {

					let currentPost = posts
					posts = currentPost.concat(data.data.channels)
					loadedPost = posts.length

					if (allPost <= loadedPost) {
						showLoadmore = false
					}

				});
			}
		);


	}



</script>

<Header/>

<main>
	<div class="wrap clear">
        <section>
            {#each posts as post}

				<article use:links>
					<Router>
						<h1 class="title"><a href="/channel/{post.permalink}">{post.title}</a></h1>
						<p class="author">Daniel Audunsson</p>
						<div class="thumb">
							<a class="play-button" href="/channel/{post.permalink}"><span></span></a>
							<div class="comment-count"><div class="fb-comments-count" data-href="{post.permalink}">0</div><span>comments</span></div>
							<div class="post-link"><img class="trs-four" src="{post.thumbnail.url}" width="700" height="394" alt="{post.title}"></div>
						</div>
						<div class="excerpt">{@html post.content.html.substr(0, 590)}</div>
						<a class="button view-article" href="/channel/{post.permalink}">Read More</a>
					</Router>
				</article>

            {:else}
                <div class="loader"></div>
            {/each}

			{#if showLoadmore}
				<button class="loadmore" on:click="{() => loadMore()}">Load More</button>
			{/if}
     
        </section>
        <aside>
            <Sidebar/>
        </aside>
    </div>
</main>
<Footer/>

<style type="text/scss">

main {
	margin-top: 64px;
	padding: 1rem;

	section {
		margin-bottom: 2rem;

		article {
			padding: 45px 0;
			border-bottom: 1px solid #ededed;

			&:first-child {
				padding-top: 0;
			}

			&:last-child {
				border: none;
			}

			h1.title {
				margin-bottom: 1rem;
				line-height: 1.9rem;

				a {
					font-weight: lighter;
					margin: 0;
					color: #0047ab;
				}
			}

			.thumb {
				position: relative;
				margin-bottom: 20px;
				transition: all .4s;
				padding-top: 56.25%;
				width: 100%;
				background: #efefef;
				border: 1px solid #d8d8d8;

				.post-link {
					width: 100%;
					height: 100%;
					position: absolute;
					overflow: hidden;
					top: 0;
					z-index: 1;

					img {
						width: 100%;
						object-fit: cover;
					}
				}

				.play-button {
					width: 100%;
					height: 100%;
					position: absolute;
					display: grid;
					align-items: center;
					align-content: center;
					z-index: 2;
					top: 0;
					display: flex;
					align-items: center;
					justify-content: center;

					span {
						width: 70px;
						height: 70px;
						margin: 0 auto;
						display: flex;
						align-items: center;
						justify-content: center;
						background: #52525299;
						border-radius: 50%;
						-webkit-transition: all .4s;
						-o-transition: all .4s;
						transition: all .4s;

						&:before {
							content: " ";
							display: block;
							position: relative;
							left: 3px;
							width: 0;
							height: 0;
							border-top: 12px solid transparent;
							border-left: 16px solid white;
							border-bottom: 12px solid transparent;
							-webkit-transition: all .4s;
							-o-transition: all .4s;
							transition: all .4s;
						}
					}
					

					
				}

				&:hover {
					box-shadow: 0 2px 20px 0 #000000c9;
					
					.play-button {
						span {
							width: 80px;
								height: 80px;
								background: #f7f3f3a1;

							&:before {
								border-left: 16px solid #403d3d;
							}
						}
					}
				}

				.comment-count {
					position: absolute;
					background: #000;
					color: #fff;
					font-size: 22px;
					padding: 10px 16px;
					text-align: center;
					top: 10px;
					left: 10px;
					max-width: 40px;
					z-index: 3;

					> span {
						display: block;
						font-size: 8px;
						text-transform: uppercase;
					}
				}
			}

			a.view-article {
				font-size: 0.8rem;
				position: relative;
				padding: 0.4rem 0.9rem;
			}
		}

		.loadmore {
			width: 100%;
			background: #0047ab;
			display: block;
			font-size: 1rem;
			padding: 0.7rem 1.9rem;
			margin: 1.6rem auto 0;
		}
	}
}



@media (min-width: 769px ) {
	main {
		.wrap {
			display: grid;
			grid-template-columns: auto 330px;
			gap: 1rem;
		}
	}
}

@media (min-width: 1025px ) {
	main {
		padding: 3rem;

		.wrap {
			gap: 3rem;
		}
	}
}

</style>